Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 158303 - pvm for x86_64 builds requires -fPIC to be able to link to 3rd party object
Summary: pvm for x86_64 builds requires -fPIC to be able to link to 3rd party object
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: pvm
Version: 3.0
Hardware: x86_64
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jason Vas Dias
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks: 187539
TreeView+ depends on / blocked
 
Reported: 2005-05-20 14:16 UTC by Tru Huynh
Modified: 2007-11-30 22:07 UTC (History)
0 users

Fixed In Version: RHBA-2006-0320
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2006-05-10 21:49:00 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2006:0320 normal SHIPPED_LIVE pvm bug fix update 2006-07-20 01:18:00 UTC

Description Tru Huynh 2005-05-20 14:16:34 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.7.8) Gecko/20050512 Firefox/1.0.4

Description of problem:
gcc pypvm_coremodule.o \
                -o pypvm_coremodule.so \
                -shared --L. -L/usr/share/pvm3/lib/LINUXX86_64
-L/usr/share/pvm3/pvmgs/LINUXX86_64 -L/usr/lib/pvm3/lib/LINUX/ -lm -lpvm3
-lgpvm3
/usr/bin/ld: /usr/share/pvm3/lib/LINUXX86_64/libpvm3.a(lpvmcat.o): relocation
R_X86_64_32 can not be used when making a shared object; recompile with -fPIC
/usr/share/pvm3/lib/LINUXX86_64/libpvm3.a: could not read symbols: Bad value
collect2: ld returned 1 exit status


Version-Release number of selected component (if applicable):
pvm-3.4.4-22.x86_64

How reproducible:
Always

Steps to Reproduce:
1. http://pypvm.sourceforge.net/pypvm-0.94.tar.gz
2. tar xzvf pypvm-0.94.tar.gz
3. cd pypvm-0.94
4. ./configure --host=i386-linux-gnu --build=i386-linux-gnu
5. patch the Makefile for python2.2 and add the pvm3 include/libs (patch joined)
6. make

this is only one example , it probably happens with every package that links
against libpvm3

Actual Results:  error at the link stage (current pvm is built without -fPIC)


Expected Results:  no error at the link stage (if pvm is built with -fPIC)

Additional info:

this one line fix the pvm issue in the pvm.spec file
[tru@sillage SPECS]$ diff -uNr pvm.spec pvm.spec.new 
--- pvm.spec    2004-06-25 18:46:31.000000000 +0200
+++ pvm.spec.new        2005-05-20 15:39:36.000000000 +0200
@@ -74,7 +74,9 @@
 # Patch the LINUXX86_64.def file to look in lib64 dirs as well for libraries.
 for I in S390X X86_64 PPC64; do
 perl -p -i -e "s|ARCHDLIB      =|ARCHDLIB      = -L/usr/lib64 -L/usr/X11R6/lib64|" conf/LINUX$I.def
+perl -p -i -e "s|ARCHCFLAGS    =|ARCHCFLAGS    = -fPIC |" conf/LINUX$I.def
 perl -p -i -e "s|ARCHLIB       =|ARCHLIB       = -L/usr/lib64 -L/usr/X11R6/lib64|" conf/LINUX$I.def
+
 done
 
 %define pvm_arch %(echo %{_os}%{_target_cpu} | tr 'a-z' 'A-Z')

Comment 1 Jason Vas Dias 2005-06-01 21:16:51 UTC
This bug is now fixed with pvm-3.4.5-5_EL3, which should be in
RHEL-3-U6, but which meanwhile can be downloaded from:
http://people.redhat.com/~jvdias/pvm/RHEL-3 
Please try it out and let me know of any issues - thank you.


Comment 9 Red Hat Bugzilla 2006-05-10 21:49:00 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2006-0320.html



Note You need to log in before you can comment on or make changes to this bug.